VERSION 5.00
Begin VB.Form frmConvert 
   Caption         =   "Converting Numbers"
   ClientHeight    =   4350
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4755
   Icon            =   "frmConvert.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   4350
   ScaleWidth      =   4755
   StartUpPosition =   2  'CenterScreen
   Begin VB.Frame Frame2 
      Height          =   1965
      Left            =   225
      TabIndex        =   12
      Top             =   2175
      Width           =   4365
      Begin VB.TextBox txtRevResult 
         Height          =   315
         Left            =   1800
         Locked          =   -1  'True
         TabIndex        =   6
         TabStop         =   0   'False
         Top             =   1125
         Width           =   2490
      End
      Begin VB.CommandButton cmdReverse 
         Caption         =   "Convert N --> Dec"
         Default         =   -1  'True
         Height          =   315
         Left            =   2700
         TabIndex        =   7
         Top             =   1575
         Width           =   1590
      End
      Begin VB.TextBox txtRevSource 
         Height          =   315
         Left            =   1800
         TabIndex        =   4
         Top             =   225
         Width           =   2490
      End
      Begin VB.TextBox txtRevBase 
         Height          =   315
         Left            =   3900
         TabIndex        =   5
         Top             =   675
         Width           =   390
      End
      Begin VB.Label Label1 
         Caption         =   "Decimal Number"
         Height          =   240
         Index           =   0
         Left            =   150
         TabIndex        =   15
         Top             =   1200
         Width           =   1665
      End
      Begin VB.Label Label1 
         Caption         =   "Converted Number"
         Height          =   240
         Index           =   4
         Left            =   150
         TabIndex        =   14
         Top             =   300
         Width           =   1665
      End
      Begin VB.Label Label1 
         Caption         =   "Convert From Base"
         Height          =   240
         Index           =   5
         Left            =   150
         TabIndex        =   13
         Top             =   750
         Width           =   1665
      End
   End
   Begin VB.Frame Frame1 
      Height          =   1965
      Left            =   225
      TabIndex        =   8
      Top             =   75
      Width           =   4365
      Begin VB.TextBox txtBase 
         Height          =   315
         Left            =   3900
         TabIndex        =   1
         Top             =   675
         Width           =   390
      End
      Begin VB.TextBox txtSource 
         Height          =   315
         Left            =   1800
         TabIndex        =   0
         Top             =   225
         Width           =   2490
      End
      Begin VB.TextBox txtResult 
         Height          =   315
         Left            =   1800
         Locked          =   -1  'True
         TabIndex        =   2
         TabStop         =   0   'False
         Top             =   1125
         Width           =   2490
      End
      Begin VB.CommandButton cmdConvert 
         Caption         =   "Convert Dec --> N"
         CausesValidation=   0   'False
         Height          =   315
         Left            =   2700
         TabIndex        =   3
         Top             =   1575
         Width           =   1590
      End
      Begin VB.Label Label1 
         Caption         =   "Decimal Number"
         Height          =   240
         Index           =   1
         Left            =   75
         TabIndex        =   11
         Top             =   225
         Width           =   1665
      End
      Begin VB.Label Label1 
         Caption         =   "Target Base"
         Height          =   240
         Index           =   2
         Left            =   75
         TabIndex        =   10
         Top             =   675
         Width           =   1665
      End
      Begin VB.Label Label1 
         Caption         =   "Converted Number"
         Height          =   240
         Index           =   3
         Left            =   75
         TabIndex        =   9
         Top             =   1125
         Width           =   1665
      End
   End
End
Attribute VB_Name = "frmConvert"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub cmdConvert_Click()
If Len(txtSource.Text) = 0 Then Exit Sub
txtResult.Text = ConvertDecToBaseN(CDbl(txtSource.Text), CByte(txtBase.Text))
End Sub

Private Sub cmdReverse_Click()
If Len(txtRevSource.Text) = 0 Then Exit Sub
txtRevResult.Text = ConvertBaseNToDec(txtRevSource.Text, CByte(txtRevBase.Text))
End Sub

Public Function ConvertDecToBaseN(ByVal dValue As Double, Optional ByVal byBase As Byte = 16) As String
Const BASENUMBERS As String = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ"
Dim sResult As String
Dim dRemainder As Double

On Error GoTo ErrorHandler

sResult = ""

If (byBase < 2) Or (byBase > 36) Then GoTo Done

dValue = Abs(dValue)

Do
    dRemainder = dValue - (byBase * Int((dValue / byBase)))
    sResult = Mid$(BASENUMBERS, dRemainder + 1, 1) & sResult
    dValue = Int(dValue / byBase)

Loop While (dValue > 0)

Done:
    ConvertDecToBaseN = sResult
Exit Function

ErrorHandler:
    Err.Raise Err.Number, "ConvertDecToBaseN", Err.Description
End Function

Public Function ConvertBaseNToDec(ByVal dValue As String, Optional ByVal byBase As Byte = 16) As String
Const BASENUMBERS As String = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ"
Dim sResult As String
Dim lReturn As Double
Dim n As Integer

On Error GoTo Handler

If (byBase < 2) Or (byBase > 36) Then Exit Function

n = 0

Do
    lReturn = ((InStr(1, BASENUMBERS, Mid(dValue, (Len(dValue) - n), 1)) - 1) * (byBase ^ n)) + lReturn
    n = n + 1
Loop Until n = Len(dValue)

ConvertBaseNToDec = CStr(lReturn)

Exit Function

Handler:
    Err.Raise Err.Number, "ConvertBaseNToDec", Err.Description
End Function


Private Sub txtRevSource_GotFocus()
cmdReverse.Default = True
End Sub

Private Sub txtRevSource_KeyPress(KeyAscii As Integer)
KeyAscii = Asc(UCase(Chr(KeyAscii)))
End Sub

Private Sub txtSource_GotFocus()
cmdConvert.Default = True
End Sub
